> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Service Account Tokens

> Lists tokens for a service account.

`Unary` · [`Service Accounts`](/docs/api-reference/generated/service-account/overview)

Lists tokens for a service account.

Use this method to:

* View all tokens for a service account
* Audit token usage
* Identify tokens to revoke

Requires impersonation: First obtain a short-lived access token via
CreateServiceAccountAccessToken, then use it to call this method.
The service account ID is derived from the caller's identity.

### Examples

* List tokens:

  ```yaml theme={null}
  pagination:
    pageSize: 20
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.ServiceAccountService/ListServiceAccountTokens
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.ServiceAccountService/ListServiceAccountTokens" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "pagination": {
      "pageSize": 1
    }
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.pagination_pb2 as pagination_pb2
  import gitpod.v1.service_account_pb2 as service_account_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = service_account_pb2.ListServiceAccountTokensRequest(
      pagination=pagination_pb2.PaginationRequest(
          page_size=1,
      ),
  )
  response = ona.services.service_account.list_service_account_tokens(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ListServiceAccountTokensRequestSchema } from "@gitpod/sdk/gitpod/v1/service_account_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(ListServiceAccountTokensRequestSchema, {
      pagination: {
        pageSize: 1,
      },
    });
    const response = await ona.services.serviceAccount.listServiceAccountTokens(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.ListServiceAccountTokensRequest{
  		Pagination: &gitpodpb.PaginationRequest{
  			PageSize: 1,
  		},
  	})
  	response, err := ona.Services.ServiceAccount.ListServiceAccountTokens(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "pagination": {
      "pageSize": 1
    }
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.ListServiceAccountTokensRequest`

| Field        | Type                                                    | Required | Description |
| ------------ | ------------------------------------------------------- | -------- | ----------- |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request) | No       |             |

## Response

`gitpod.v1.ListServiceAccountTokensResponse`

| Field        | Type                                                                  | Required | Description |
| ------------ | --------------------------------------------------------------------- | -------- | ----------- |
| `tokens`     | array of [ServiceAccountToken](#type-gitpod-v1-service-account-token) | No       |             |
| `pagination` | [PaginationResponse](#type-gitpod-v1-pagination-response)             | No       |             |

## Related types

<a id="type-gitpod-v1-pagination-request" />

<Accordion title="PaginationRequest">
  `gitpod.v1.PaginationRequest`

  | Field      | Type    | Required | Description                                                                                                                              |
  | ---------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
  | `pageSize` | integer | No       | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
  | `token`    | string  | No       | Token for the next set of results that was returned as next\_token of a PaginationResponse                                               |
</Accordion>

<a id="type-gitpod-v1-pagination-response" />

<Accordion title="PaginationResponse">
  `gitpod.v1.PaginationResponse`

  | Field       | Type   | Required | Description                                                                             |
  | ----------- | ------ | -------- | --------------------------------------------------------------------------------------- |
  | `nextToken` | string | No       | Token passed for retrieving the next set of results. Empty if there are no more results |
</Accordion>

<a id="type-gitpod-v1-service-account-token" />

<Accordion title="ServiceAccountToken">
  ServiceAccountToken represents metadata about a service account token.
  The actual token value is only returned once during creation.

  `gitpod.v1.ServiceAccountToken`

  | Field              | Type                               | Required | Description                      |
  | ------------------ | ---------------------------------- | -------- | -------------------------------- |
  | `id`               | string                             | No       | Constraints: `string.uuid=true`. |
  | `serviceAccountId` | string                             | No       | Constraints: `string.uuid=true`. |
  | `description`      | string                             | No       |                                  |
  | `creator`          | [Subject](#type-gitpod-v1-subject) | No       |                                  |
  | `createdAt`        | RFC 3339 timestamp                 | No       |                                  |
  | `expiresAt`        | RFC 3339 timestamp                 | No       |                                  |
  | `lastUsed`         | RFC 3339 timestamp                 | No       |                                  |
</Accordion>

<a id="type-gitpod-v1-subject" />

<Accordion title="Subject">
  `gitpod.v1.Subject`

  | Field       | Type                                   | Required | Description                                                                      |
  | ----------- | -------------------------------------- | -------- | -------------------------------------------------------------------------------- |
  | `id`        | string                                 | No       | id is the UUID of the subject Constraints: `ignore=1, string.uuid=true`.         |
  | `principal` | [Principal](#enum-gitpod-v1-principal) | No       | Principal is the principal of the subject Constraints: `enum.defined_only=true`. |
</Accordion>

<a id="enum-gitpod-v1-principal" />

<Accordion title="Principal">
  | Value                       | Number | Description |
  | --------------------------- | -----: | ----------- |
  | `PRINCIPAL_UNSPECIFIED`     |      0 |             |
  | `PRINCIPAL_ACCOUNT`         |      1 |             |
  | `PRINCIPAL_USER`            |      2 |             |
  | `PRINCIPAL_RUNNER`          |      3 |             |
  | `PRINCIPAL_ENVIRONMENT`     |      4 |             |
  | `PRINCIPAL_SERVICE_ACCOUNT` |      5 |             |
  | `PRINCIPAL_RUNNER_MANAGER`  |      6 |             |
</Accordion>
